From 90a70ac1023ff71c59a28e9160bf30334e0afc55 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 30 2016 18:13:38 +0000
Subject: [PATCH 375/1001] Merge branch 'feature/redis-workload' into develop


---

diff --git a/cache-coverage.py b/cache-coverage.py
new file mode 100755
index 0000000..8aad708
--- /dev/null
+++ b/cache-coverage.py
@@ -0,0 +1,43 @@
+#!/usr/bin/env python
+""" cache coverage checker.
+
+Runs through all possible cache keys and checks if there is a corresponding
+value already cached for it.
+
+Useful as a sanity check during development.
+
+Could make a good nagios check one day.  If the cache coverage is below 50%,
+then the site will be very slow.  We should run some sort of script that
+forcibly re-warms the cache.
+
+Authors:    Ralph Bean <rbean@redhat.com>
+"""
+
+import sys
+import dogpile.cache
+
+import hubs.widgets.base
+import hubs.models
+
+import fedmsg.config
+
+config = fedmsg.config.load_config()
+
+empty, full = 0, 0
+session = hubs.models.init(config['hubs.sqlalchemy.uri'])
+for widget in session.query(hubs.models.Widget).all():
+    key = hubs.widgets.base.cache_key_generator(widget, **widget.config)
+    result = hubs.widgets.base.cache.get(key, ignore_expiration=True)
+    if isinstance(result, dogpile.cache.api.NoValue):
+        empty += 1
+    else:
+        full += 1
+    sys.stdout.write('.')
+    sys.stdout.flush()
+sys.stdout.write('\n')
+sys.stdout.flush()
+
+total = empty + full
+print full, "cache values found. ", empty, "are missing."
+print full / float(total) * 100, "percent cache coverage."
+
diff --git a/fedmsg.d/testconfig.py b/fedmsg.d/testconfig.py
index e85072e..c2f68a1 100644
--- a/fedmsg.d/testconfig.py
+++ b/fedmsg.d/testconfig.py
@@ -4,6 +4,9 @@ config = {
     # Production ready.
     'hubs.sqlalchemy.uri': 'sqlite:////var/tmp/hubs.db',
 
+    # For communication between fedmsg-hub and the cache worker farm
+    'hubs.redis.work-queue-name': 'fedora-hubs-work-queue',
+
     'endpoints': {
         "fedora-infrastructure": [
             "tcp://hub.fedoraproject.org:9940",
diff --git a/hubs/app.py b/hubs/app.py
index 851e850..47099c4 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -1,3 +1,4 @@
+import datetime
 import functools
 import logging
 import os
@@ -17,10 +18,12 @@ from hubs.utils import username2avatar
 
 app = flask.Flask(__name__)
 
-# Register a global filter, useful for displaying user images
+# Register some useful global filters.
+def days_since(then):
+    return (datetime.datetime.utcnow() - then).days
+app.template_filter('days_since')(days_since)
 app.template_filter('avatar')(hubs.widgets.base.avatar)
 
-
 logging.basicConfig()
 
 
diff --git a/hubs/consumer.py b/hubs/consumer.py
index c6e0d7b..bde01c7 100755
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -1,8 +1,8 @@
 # The fedora hubs backend daemon
 
 import collections
+import json
 import threading
-import time
 
 import munch
 
@@ -10,12 +10,13 @@ import datanommer.models
 import fedmsg.consumers
 import fedmsg.meta
 
+import retask.task
+import retask.queue
+
 import hubs.app
 import hubs.models
 import hubs.widgets
 
-from hubs.widgets.base import invalidate_cache
-
 import logging
 log = logging.getLogger("hubs")
 
@@ -43,10 +44,13 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         super(CacheInvalidatorExtraordinaire, self).__init__(*args, **kwargs)
 
         self.uri = self.hub.config.get('hubs.sqlalchemy.uri', None)
+        self.queue_name = self.hub.config.get('hubs.redis.work-queue-name', None)
         self.junk_suffixes = self.hub.config.get('hubs.junk_suffixes', [])
 
         if not self.uri:
             raise ValueError('hubs.sqlalchemy.uri must be present')
+        if not self.queue_name:
+            raise ValueError('hubs.sqlalchemy.uri must be present')
 
         fedmsg.meta.make_processors(**self.hub.config)
 
@@ -59,11 +63,19 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
 
         datanommer.models.init(self.hub.config['datanommer.sqlalchemy.uri'])
 
+        # XXX - for flask.url_for to work
+        hubs.app.app.config['SERVER_NAME'] = '0.0.0.0:5000'
+
         log.debug("CacheInvalidatorExtraordinaire initialized")
 
     def make_session(self):
         return hubs.models.init(self.uri)
 
+    def make_queue(self):
+        queue = retask.queue.Queue(self.queue_name)
+        queue.connect()
+        return queue
+
     def rebuild_hubs_hint_lookups(self, session):
         self.checks_by_topic = collections.defaultdict(list)
         self.checks_by_category = collections.defaultdict(list)
@@ -105,10 +117,11 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         return self.checks_by_topic and self.checks_by_category
 
     def consume(self, raw_msg):
+        queue = self.make_queue()
         session = self.make_session()
         try:
             with hubs.app.app.app_context():  # so url_for works
-                self.work(session, raw_msg)
+                self.work(session, queue, raw_msg)
             session.commit()  # transaction is committed here
         except:
             session.rollback()  # rolls back the transaction
@@ -116,7 +129,7 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         finally:
             session.close()
 
-    def work(self, session, raw_msg):
+    def work(self, session, queue, raw_msg):
         topic, msg = raw_msg['topic'], raw_msg['body']
         category = topic.split('.')[3]
         usernames = fedmsg.meta.msg2usernames(msg, **self.hub.config)
@@ -126,7 +139,6 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
                 log.info("Dropping %r", topic)
                 return
 
-        start = time.time()
         log.debug("CacheInvalidatorExtraordinaire received %s %s",
                   msg['msg_id'], msg['topic'])
 
@@ -148,28 +160,19 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
             self.ubiquitous_checks,
         ], [])
 
-        statement = "Found %i checks to try for this message" % len(checks)
-        if checks:
-            log.info(statement)
-        else:
-            log.debug(statement)
+        log.debug("Found %i checks to try for this message" % len(checks))
 
         # Then, with that hopefully smaller list of checks, try them all and
         # see if any tell us that we should nuke various data caches.
         for check, widget in checks:
             if check(msg, session, widget):
-                # Get a real widget, because we update last_refreshed on it.
-                widget = hubs.models.Widget.by_idx(session, widget.idx)
-                log.info("! Invalidating cache for %r" % widget)
-                # Invalidate the cache...
-                invalidate_cache(widget, **widget.config)
-                # Rebuild it.
-                log.info("! Rebuilding cache for %r" % widget)
-                widget.module.data(session, widget, **widget.config)
-                # TODO -- fire off an EventSource notice that we updated stuff
-
-        log.debug("Done.  %0.2fs %s %s",
-                  time.time() - start, msg['msg_id'], msg['topic'])
+                task = retask.task.Task(json.dumps({
+                    'idx': widget.idx,
+                    'msg_id': msg['msg_id'],
+                }))
+                log.debug("  Sending %r to workers. (backlog is %r)" % (
+                    task, queue.length))
+                queue.enqueue(task)
 
     def stop(self):
         log.info("Cleaning up CacheInvalidatorExtraordinaire.")
diff --git a/hubs/default_config.py b/hubs/default_config.py
index a452867..a21f138 100755
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -6,5 +6,3 @@ PROMOTED_GROUPS = [
 ]
 
 HUB_OF_THE_MONTH = 'commops'
-
-SERVER_NAME = '0.0.0.0:5000'
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index dc7b229..e784ef1 100755
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -68,7 +68,8 @@ def smartcache(func):
 def invalidate_cache(widget, *args, **kwargs):
     key = cache_key_generator(widget, *args, **kwargs)
 
-    if not cache.get(key, ignore_expiration=True):
+    value = cache.get(key, ignore_expiration=True)
+    if isinstance(value, dogpile.cache.api.NoValue):
         log.debug("Not deleting cache key %s.  It is absent.", key)
         return
 
diff --git a/hubs/worker.py b/hubs/worker.py
new file mode 100755
index 0000000..fa63856
--- /dev/null
+++ b/hubs/worker.py
@@ -0,0 +1,72 @@
+import hubs.app
+import hubs.models
+
+import hubs.widgets.base
+
+import fedmsg.config
+config = fedmsg.config.load_config()
+
+import retask.queue
+
+import json
+import sys
+import logging
+import logging.config
+log = logging.getLogger('hubs.worker')
+
+
+def work(session, widget_idx):
+    # Get a real widget, because we update last_refreshed on it.
+    widget = hubs.models.Widget.by_idx(session, widget_idx)
+    log.info("! Invalidating cache for %r" % widget)
+    # Invalidate the cache...
+    hubs.widgets.base.invalidate_cache(widget, **widget.config)
+    # Rebuild it.
+    log.info("! Rebuilding cache for %r" % widget)
+    widget.module.data(session, widget, **widget.config)
+    # TODO -- fire off an EventSource notice that we updated stuff
+
+def handle(idx):
+    session = hubs.models.init(config['hubs.sqlalchemy.uri'])
+
+    try:
+        with hubs.app.app.app_context():  # so url_for works
+            work(session, idx)
+        session.commit()  # transaction is committed here
+    except:
+        session.rollback()  # rolls back the transaction
+        raise
+    finally:
+        session.close()
+
+def main(args):
+
+    # TODO -- manage signal handling for clean shutdown
+
+    logging.config.dictConfig(config['logging'])
+    logging.basicConfig()
+
+    # XXX - for flask.url_for to work
+    hubs.app.app.config['SERVER_NAME'] = '0.0.0.0:5000'
+
+    name = config['hubs.redis.work-queue-name']
+    log.info("Worker starting, connecting to retask queue %r." % name)
+    queue = retask.queue.Queue(name)
+    queue.connect()
+
+    try:
+        log.info("Entering work loop.")
+        while True:
+            task = queue.wait()  # Wait forever...  timeout is optional.
+            log.info("Working on %r.  (backlog is %r)" % (task, queue.length))
+            item = json.loads(task.data)
+            idx = item['idx']  # A widget ID
+            handle(idx)
+            log.debug("  Done.")
+    except KeyboardInterrupt:
+        pass
+
+    return 0
+
+if __name__ == '__main__':
+    sys.exit(main(sys.argv))
